<?php
require_once ('functions_requestRemote.php') ;

function chat_config($id,$a,$get_cm)
{
	global $DB,$CFG;
	require_once("../../config.php");
    require_once($CFG->dirroot."/mod/flashchat/lib.php");
	//require_once('../../calendar/lib.php');
	
    if ($id) {  
        //if (! $flashchat = get_record("flashchat", "id", $get_cm)) {
		if (! $flashchat = $DB->get_record("flashchat", array('id'=>$get_cm))) {
            error("Course module is incorrect");
        }

    } else {
        //if (! $flashchat = get_record("flashchat", "id", $a)) {
		if (! $flashchat = $DB->get_record("flashchat",array('id'=>$a))) {
            error("Course module is incorrect");
        }
    }		
		return $flashchat;
}

function checkSlash($path)
{
	if(substr($path,-1,1) != "/" && !empty($path)){
		$path = $path."/";
	}
	return $path;
}

function validate_client($client_loc){	
    $c_own_loc = '1';
    $swf = $client_loc . '123flashchat.swf';
    $headers = topcmmRequestRemote::requestRemote($swf,0);
    if($headers)
    {
        $c_own_loc = (substr($headers, 9, 3) == '200') ? "0" : "1";
    }
    return $c_own_loc;
}
function validate_data_api($data_api){   
	$da = 1;
    if(substr(topcmmRequestRemote::requestRemote($data_api,0), 9, 3) == 200){
        $da = 0;
    }
    return $da;
}
function getHostParameters($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location);
	if(!empty($content))
	{
		$pattern = '|var urlValue="(.*)"|U';
		preg_match($pattern, $content, $matches);
		if(!empty($matches[1]))
		{
			$url = $matches[1];
			$urlinfo = parse_url($url);
			return $urlinfo;
		}
		else
		{
			$pattern = '|PARAM NAME=movie VALUE="(.*)"|U';
			preg_match($pattern, $content, $matches);
			if(!empty($matches[1]))
			{
				$url = $matches[1];
				$urlinfo = parse_url($url);
				return $urlinfo;
			}
		}
		return false;
	}
}

function getRooms($flashchat)
{
    $server =  $flashchat->extendserver;
    switch ($server){
		case "0":
			$room_js = $flashchat->api_url . "rooms.js";
		break;
		case "1":
			$room_js = $flashchat->api_url . "rooms.js?group=" . $flashchat->init_group;
		break;
	}
	if($rs = topcmmRequestRemote::requestRemote($room_js,1)){
		$rooms_json = substr($rs,10,-1);
	}
	if(isset($rooms_json)){
    	return json_decode($rooms_json, true);
	}else{
		return false;
	}
}
function getUsers($flashchat){
    $context = stream_context_create(array('http' => array(
		'timeout' => 3      // Timeout in seconds
	)));
    $server =  $flashchat->extendserver;
	switch ($server){
		case "0":
			$rooms = getRooms($flashchat);
            $users = array();
            if(is_array($rooms)){
	            foreach ($rooms as $room){
					$user_js = $flashchat->api_url . "roomonlineusers.js?roomid=" . $room['id'];
					if($rs = topcmmRequestRemote::requestRemote($user_js,1)){
						$users = array_merge($users, json_decode(substr($rs,20,-1),true));
					}
				}
            }
			$users_json = json_encode($users);
		break;
		case "1":
			$user_js = $flashchat->api_url . "roomonlineusers.js?group=" . $flashchat->init_group;
            if($rs = topcmmRequestRemote::requestRemote($user_js,1)){
				$users_json = substr($rs,20,-1);
            }
        break;
        case "2":
			$user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" .  $flashchat->chat_room_name;
            if($rs = topcmmRequestRemote::requestRemote($user_js,1)){
            	preg_match("/document.write\('(.*)'\);/",$rs,$matches);
                foreach (explode(',', $matches[1]) as $user){
                	$users[] = array('name' => $user);
                }
			}
			$users_json = json_encode($users);
		break;
	}
	 $users_json = filterUserList($users_json);
    return json_decode($users_json, true);
}
function getStatus($flashchat){
	$server = $flashchat->extendserver;
    switch ($server){
    	case "0":
        	$status_js = $flashchat->api_url . "online.js";
            if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                $status_json = substr($rs,11,-1);
            }
        break;
        case "1":
            $status_js = $flashchat->api_url . "online.js?group=" . $flashchat->init_group;
            if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                $status_json = substr($rs,11,-1);
            }
        break;
        case "2":
            $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $flashchat->chat_room_name;
            if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                preg_match("/document.write\('(.*)'\);/",$rs,$matches);
                $status['ln'] = $matches[1];
                $status_json = json_encode($status);
            }
        break;
    }
    if(isset($status_json)){
    	return json_decode($status_json,true);
    }else{
    	return false;
    }
}

function serviceGetChatStats($id,$a,$get_cm){
	$flashchat = chat_config($id,$a,$get_cm);	
	$status = getStatus($flashchat);	
	if($flashchat->user_list){
		$users = getUsers($flashchat);
	}
	if($flashchat->room_list && $flashchat->extendserver != "2"){
		$rooms = getRooms($flashchat);
	}
	$sOutputCode = '';
	if(isset($status['ln'])){
		$sOutputCode .= '<b>' . $status['ln'] . '</b> login users.';
        if (isset($status['rn'])){
            $sOutputCode = '<b>' . $status['rn'] . '</b> rooms, ' . '<b>' . $status['cn'] . '</b> connections, ' . $sOutputCode;
        }
	}
	if(isset($rooms)){
        $sOutputCode .= "<b><p>Rooms:</b> ";
        if(!$rooms) {
            $sOutputCode .= "None";
        }else{
            $xa = ' ';
            foreach($rooms as $room){
            	$js = 'onclick="window.open(\'123flashchat.php?a='.$a.'&id='.$id.'&getcm='.$get_cm.'&room='.$room['id'].'\');return false;"';  
				$sOutputCode .= $xa . '<a href="http://wwww.123flashchat.com" ' .  $js . ">" .$room['name'] ."</a>(" . $room['count'] . ")";
            	$xa = ", ";
            }
        }
    }
	if(isset($users)){
        $sOutputCode .= "</p><p><b>Users:</b> ";
        if(!$users){
            $sOutputCode .= "None</p>";
        }else{
            $xb = ' ';
            
            foreach($users as $user){
                $sOutputCode .= $xb . $user['name'];
                $xb = ', ';
            }
            $sOutputCode .= "</p>";
        }
    }
    return $sOutputCode;
}
function filterUserList($users_json){
	$user_array =  json_decode($users_json,true);
	$user_regroup_array = array();
	$user_tmp_array = array();
	foreach($user_array as $key => $val){
		if (!in_array($val['name'], $user_tmp_array)){
			$user_tmp_array[] = $val['name'];
			$user_regroup_array[$key] = $user_array[$key];
		}
	}
	return json_encode($user_regroup_array);
}
?>